using System;
using System.Diagnostics;
using System.Threading;
using System.Windows.Forms;

namespace Farineh
{
	public class AppLoader
	{
		public AppLoader()
		{

		}
		[STAThread]
		static void Main(string[] args)
		{
//				show the splash form
			SplashScreen.ShowSplashScreen();
				
//				process application startup
			DoStartup(args);

//				if the form is still shown...
//			SplashScreen.CloseForm();
		}

		static void DoStartup(string[] args)
		{
			// Modify this version, whenever changes are made such that the persisted state cannot be loaded anymore.
			string curVersion = "1.0";
			MainForm.ValidatePersistedStateVersion(curVersion);
			MainForm.StoreVersionInfo(curVersion);

			MainForm mainForm = new MainForm();
			
			bool bRunning = false;
			foreach (Process p in Process.GetProcesses(Environment.MachineName))
			{
				if (p.MainWindowHandle != IntPtr.Zero)
				{
					// Process name gets truncated!
					if (p.ProcessName == "TabbedMDI")
					{
						bRunning = true;
						MessageBox.Show("Activating the already open instance of TabbedMDI.exe.");
						MainForm.SetForegroundWindow(p.MainWindowHandle);
						break;
					}
				}
			}
			if (!bRunning)
			{
				Application.Run(mainForm);
				
			}

		}
	}
}
