﻿using System;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Windows.Forms;
using Syncfusion.Windows.Forms;

namespace OfficeApplication
{
	/// <summary>
	/// Summary description for ListBoxHavalehForm.
	/// </summary>
	public class ListBoxHavalehForm : Form
	{
		private ButtonAdv buttonAdv1;
		private ButtonAdv buttonAdv2;
		private TreeView treeView1;
		private SqlDataAdapter daHavaleh;
		private SqlConnection sqlConnection1;
		private DataView dataView1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private Container components = null;
		private dsListPreFactor dsListPreFactor1;
		private System.Data.SqlClient.SqlCommand sqlSelectCommand1;
		private System.Data.SqlClient.SqlCommand sqlInsertCommand1;
		private System.Data.SqlClient.SqlCommand sqlUpdateCommand1;
		private System.Data.SqlClient.SqlCommand sqlDeleteCommand1;
		private Int64 havalehIDFK ;

		public ListBoxHavalehForm( Int64 customerId , Int64 havalehID)
		{
			InitializeComponent();
			this.havalehIDFK = havalehID;
			this.daHavaleh.Fill( dsListPreFactor1);
			dataView1.Table = dsListPreFactor1.offPreFactor;
			dataView1.RowFilter = "cusotmerIDFK = " + customerId;
			foreach (DataRowView view1 in dataView1)
			{
				dsListPreFactor.offPreFactorRow row =
					(dsListPreFactor.offPreFactorRow) view1.Row;
				TreeNode node = new TreeNode();
				node.Text = Convert.ToString(row.ID);
				try
				{
					if (row.HavalehIDFK == havalehID)
					{
						node.Checked = true;
						treeView1.Nodes.Add(node);
					}
					else
						node.Checked = false;
				}
				catch (Exception e)
				{
					node.Checked = false;
					treeView1.Nodes.Add(node);
				}

				node.Tag = "0"; // for modified
				
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonAdv1 = new Syncfusion.Windows.Forms.ButtonAdv();
			this.buttonAdv2 = new Syncfusion.Windows.Forms.ButtonAdv();
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.daHavaleh = new System.Data.SqlClient.SqlDataAdapter();
			this.sqlDeleteCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlInsertCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlSelectCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlUpdateCommand1 = new System.Data.SqlClient.SqlCommand();
			this.dataView1 = new System.Data.DataView();
			this.dsListPreFactor1 = new OfficeApplication.dsListPreFactor();
			((System.ComponentModel.ISupportInitialize)(this.dataView1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dsListPreFactor1)).BeginInit();
			this.SuspendLayout();
			// 
			// buttonAdv1
			// 
			this.buttonAdv1.Appearance = Syncfusion.Windows.Forms.ButtonAppearance.WindowsXP;
			this.buttonAdv1.ComboEditBackColor = System.Drawing.Color.Empty;
			this.buttonAdv1.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.buttonAdv1.Location = new System.Drawing.Point(16, 176);
			this.buttonAdv1.Name = "buttonAdv1";
			this.buttonAdv1.Size = new System.Drawing.Size(48, 23);
			this.buttonAdv1.TabIndex = 2;
			this.buttonAdv1.Text = "انصراف";
			this.buttonAdv1.UseVisualStyle = true;
			this.buttonAdv1.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// buttonAdv2
			// 
			this.buttonAdv2.Appearance = Syncfusion.Windows.Forms.ButtonAppearance.WindowsXP;
			this.buttonAdv2.ComboEditBackColor = System.Drawing.Color.Empty;
			this.buttonAdv2.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonAdv2.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.buttonAdv2.Location = new System.Drawing.Point(72, 176);
			this.buttonAdv2.Name = "buttonAdv2";
			this.buttonAdv2.Size = new System.Drawing.Size(48, 23);
			this.buttonAdv2.TabIndex = 3;
			this.buttonAdv2.Text = "ذخیره";
			this.buttonAdv2.UseVisualStyle = true;
			this.buttonAdv2.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// treeView1
			// 
			this.treeView1.CheckBoxes = true;
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Top;
			this.treeView1.ImageIndex = -1;
			this.treeView1.Location = new System.Drawing.Point(0, 0);
			this.treeView1.Name = "treeView1";
			this.treeView1.SelectedImageIndex = -1;
			this.treeView1.Size = new System.Drawing.Size(136, 168);
			this.treeView1.TabIndex = 5;
			this.treeView1.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterCheck);
			// 
			// daHavaleh
			// 
			this.daHavaleh.DeleteCommand = this.sqlDeleteCommand1;
			this.daHavaleh.InsertCommand = this.sqlInsertCommand1;
			this.daHavaleh.SelectCommand = this.sqlSelectCommand1;
			this.daHavaleh.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								new System.Data.Common.DataTableMapping("Table", "offPreFactor", new System.Data.Common.DataColumnMapping[] {
																																																				new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																				new System.Data.Common.DataColumnMapping("date", "date"),
																																																				new System.Data.Common.DataColumnMapping("cusotmerIDFK", "cusotmerIDFK"),
																																																				new System.Data.Common.DataColumnMapping("HavalehIDFK", "HavalehIDFK")})});
			this.daHavaleh.UpdateCommand = this.sqlUpdateCommand1;
			// 
			// sqlDeleteCommand1
			// 
			this.sqlDeleteCommand1.CommandText = @"DELETE FROM offPreFactor WHERE (ID = @Original_ID) AND (HavalehIDFK = @Original_HavalehIDFK OR @Original_HavalehIDFK IS NULL AND HavalehIDFK IS NULL) AND (cusotmerIDFK = @Original_cusotmerIDFK OR @Original_cusotmerIDFK IS NULL AND cusotmerIDFK IS NULL) AND (date = @Original_date OR @Original_date IS NULL AND date IS NULL)";
			this.sqlDeleteCommand1.Connection = this.sqlConnection1;
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ID", System.Data.SqlDbType.BigInt, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_HavalehIDFK", System.Data.SqlDbType.BigInt, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "HavalehIDFK", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_cusotmerIDFK", System.Data.SqlDbType.BigInt, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "cusotmerIDFK", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_date", System.Data.SqlDbType.VarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "date", System.Data.DataRowVersion.Original, null));
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = Farineh.XmlManager.GetConnectionOffice();
//			this.sqlConnection1.ConnectionString = "workstation id=SHADMEHR;packet size=4096;integrated security=SSPI;data source=\".\"" +
//				";persist security info=False;initial catalog=OfficeDB";
//			// 
			// sqlInsertCommand1
			// 
			this.sqlInsertCommand1.CommandText = "INSERT INTO offPreFactor(date, cusotmerIDFK, HavalehIDFK) VALUES (@date, @cusotme" +
				"rIDFK, @HavalehIDFK); SELECT ID, date, cusotmerIDFK, HavalehIDFK FROM offPreFact" +
				"or WHERE (ID = @@IDENTITY)";
			this.sqlInsertCommand1.Connection = this.sqlConnection1;
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@date", System.Data.SqlDbType.VarChar, 10, "date"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@cusotmerIDFK", System.Data.SqlDbType.BigInt, 8, "cusotmerIDFK"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@HavalehIDFK", System.Data.SqlDbType.BigInt, 8, "HavalehIDFK"));
			// 
			// sqlSelectCommand1
			// 
			this.sqlSelectCommand1.CommandText = "SELECT ID, date, cusotmerIDFK, HavalehIDFK FROM offPreFactor";
			this.sqlSelectCommand1.Connection = this.sqlConnection1;
			// 
			// sqlUpdateCommand1
			// 
			this.sqlUpdateCommand1.CommandText = @"UPDATE offPreFactor SET date = @date, cusotmerIDFK = @cusotmerIDFK, HavalehIDFK = @HavalehIDFK WHERE (ID = @Original_ID) AND (HavalehIDFK = @Original_HavalehIDFK OR @Original_HavalehIDFK IS NULL AND HavalehIDFK IS NULL) AND (cusotmerIDFK = @Original_cusotmerIDFK OR @Original_cusotmerIDFK IS NULL AND cusotmerIDFK IS NULL) AND (date = @Original_date OR @Original_date IS NULL AND date IS NULL); SELECT ID, date, cusotmerIDFK, HavalehIDFK FROM offPreFactor WHERE (ID = @ID)";
			this.sqlUpdateCommand1.Connection = this.sqlConnection1;
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@date", System.Data.SqlDbType.VarChar, 10, "date"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@cusotmerIDFK", System.Data.SqlDbType.BigInt, 8, "cusotmerIDFK"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@HavalehIDFK", System.Data.SqlDbType.BigInt, 8, "HavalehIDFK"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ID", System.Data.SqlDbType.BigInt, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_HavalehIDFK", System.Data.SqlDbType.BigInt, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "HavalehIDFK", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_cusotmerIDFK", System.Data.SqlDbType.BigInt, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "cusotmerIDFK", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_date", System.Data.SqlDbType.VarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "date", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ID", System.Data.SqlDbType.BigInt, 8, "ID"));
			// 
			// dataView1
			// 
			this.dataView1.ApplyDefaultSort = true;
			this.dataView1.Sort = "ID";
			this.dataView1.Table = this.dsListPreFactor1.offPreFactor;
			// 
			// dsListPreFactor1
			// 
			this.dsListPreFactor1.DataSetName = "dsListPreFactor";
			this.dsListPreFactor1.Locale = new System.Globalization.CultureInfo("fa-IR");
			// 
			// ListBoxHavalehForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(136, 206);
			this.Controls.Add(this.treeView1);
			this.Controls.Add(this.buttonAdv2);
			this.Controls.Add(this.buttonAdv1);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Name = "ListBoxHavalehForm";
			this.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.ShowInTaskbar = false;
			this.Text = "لیست پیش فاکتور ها";
			this.Load += new System.EventHandler(this.ListBoxHavalehForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataView1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dsListPreFactor1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void ListBoxHavalehForm_Load(object sender, EventArgs e)
		{
			
		}

		private void btnClose_Click(object sender, EventArgs e)
		{
			this.Close();
		}

		private void btnSave_Click(object sender, EventArgs e)
		{
			foreach (TreeNode node in treeView1.Nodes)
			{
				if ( node.Tag.ToString() == "1")
				{
					dsListPreFactor.offPreFactorRow updatingRow = dsListPreFactor1.offPreFactor.FindByID(
						Convert.ToInt64(node.Text));
					if ( node.Checked )
						updatingRow.HavalehIDFK = havalehIDFK;
					else
					{
						updatingRow.SetHavalehIDFKNull();
					}
				}
			}

			try
			{
				daHavaleh.Update(dsListPreFactor1);
			}
			catch (Exception e1)
			{
				Console.Write(e1);
			}
			this.Close();
		}

		private void treeView1_AfterCheck(object sender, TreeViewEventArgs e)
		{
			e.Node.Tag  = "1";
		}
	}
	public class Element
	{
		public bool Check;
		public Int64 ID;
		public bool Modified = false;
	}
}
