package actions;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import dataaccess.ProductionOrderDAO;
import entity.ProductionOrderEntity;
import forms.ProductionOrderForm;

/**
 * @struts.action name="productionorderAF" path= "/productionordercrud"

 * @struts.action-forward name="productionorder" path="/jsps/productionOrder.jsp"
 * @struts.action-forward name="productionorder.update" path="/jsps/productionOrder.update.jsp"
 * @struts.action-forward name="productionorder.list" path="/jsps/productionOrder.list.jsp"
 * @struts.action-forward name="error" path="/jsps/error.jsp"
 */
public class ProductionOrderCRUDAction extends BaseAction
{
    private ProductionOrderEntity productionOrderEntity;

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        String actionName = httpServletRequest.getParameter("Action_Name");
        productionOrderEntity = ( ProductionOrderEntity) makeEntityFromForm(actionForm);

//        System.out.println("================>>>>>>>>>>>>");
//        System.out.println(productionOrderEntity.getName());
//        System.out.println(productionOrderEntity.getFamily());
//        System.out.println("================>>>>>>>>>>>>");

        if( actionName.equalsIgnoreCase("add")) {

            return actionMapping.findForward("productionOrder");

        } else if( actionName.equalsIgnoreCase("commitAdd")) {

            ProductionOrderDAO.save(productionOrderEntity);
            List list = ProductionOrderDAO.list();
            httpServletRequest.getSession().setAttribute("ProductionOrderList", list);
            return actionMapping.findForward("productionOrder.list");

        } else if( actionName.equalsIgnoreCase("update")) {

            String ID = httpServletRequest.getParameter("ID");
            Long productionOrderID = Long.decode(ID);

            ProductionOrderEntity poe = (ProductionOrderEntity) ProductionOrderDAO.findByID(productionOrderID);

            httpServletRequest.getSession().setAttribute("ProductionOrder", makeFormFromEntity( poe));
            httpServletRequest.getSession().setAttribute("ID", ID);

            return actionMapping.findForward("productionOrder.update");

        } else if( actionName.equalsIgnoreCase("commitUpdate")) {

            Long ID = Long.decode((String)httpServletRequest.getSession().getAttribute("ID"));

            ProductionOrderDAO.update(ID, productionOrderEntity);

            List list = ProductionOrderDAO.list();
            httpServletRequest.getSession().setAttribute("ProductionOrdersList", list);

            return actionMapping.findForward("productionOrder.list");

        } else if( actionName.equalsIgnoreCase("list")) {

            List list = ProductionOrderDAO.list();
            httpServletRequest.getSession().setAttribute("ProductionOrdersList", list);

            return actionMapping.findForward("productionOrder.list");

        }

        return actionMapping.findForward("error");
    }

    protected Object makeEntityFromForm(ActionForm actionForm) 
    {
        ProductionOrderForm poForm = (ProductionOrderForm) actionForm;
        ProductionOrderEntity poEntity = new ProductionOrderEntity();

        poEntity.setDate( poForm.getDate());

        return poEntity;
    }

    protected ActionForm makeFormFromEntity( Object o) 
    {
        ProductionOrderEntity poEntity = (ProductionOrderEntity) o;
        ProductionOrderForm poForm = new ProductionOrderForm();

        poForm.setDate( poEntity.getDate());

        return poForm;
    }
}
