package actions;

import java.sql.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import dataaccess.SentHavalehDAO;
import entity.SentHavalehEntity;
import forms.SentHavalehForm;

/**
 * @struts.action name="senthavalehAF" path= "/senthavalehcrud"

 * @struts.action-forward name="senthavaleh" path="/jsps/senthavaleh.jsp"
 * @struts.action-forward name="senthavaleh.update" path="/jsps/senthavaleh.update.jsp"
 * @struts.action-forward name="senthavaleh.update.list" path="/jsps/senthavaleh.update.list.jsp"
 * @struts.action-forward name="error" path="/jsps/error.jsp"
 */
public class SentHavalehCRUDAction extends BaseAction{
    private SentHavalehEntity sentHavalehEntity;

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm, HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        String actionName = httpServletRequest.getParameter("Action_Name");
        sentHavalehEntity = (SentHavalehEntity) makeEntityFromForm(actionForm);

        if( actionName.equalsIgnoreCase("add")) {

            return actionMapping.findForward("senthavaleh");

        } else if( actionName.equalsIgnoreCase("commitAdd")) {

            SentHavalehDAO.save(sentHavalehEntity);
            List list = SentHavalehDAO.list();
            httpServletRequest.getSession().setAttribute("SentHavalehList", list);
            return actionMapping.findForward("senthavaleh.update.list");

        } else if( actionName.equalsIgnoreCase("update")) {

            String ID = httpServletRequest.getParameter("ID");
            Long sentHavalehID = Long.decode(ID);

            SentHavalehEntity she = (SentHavalehEntity) SentHavalehDAO.findByID(sentHavalehID);

            httpServletRequest.getSession().setAttribute("SentHavaleh", makeFormFromEntity( she));
            httpServletRequest.getSession().setAttribute("ID", ID);

            return actionMapping.findForward("senthavaleh.update");

        } else if( actionName.equalsIgnoreCase("commitUpdate")) {

            Long ID = Long.decode((String)httpServletRequest.getSession().getAttribute("ID"));

            SentHavalehDAO.update(ID, sentHavalehEntity);

            List list = SentHavalehDAO.list();
            httpServletRequest.getSession().setAttribute("SentHavalehList", list);

            return actionMapping.findForward("senthavaleh.list");

        } else if( actionName.equalsIgnoreCase("updateList")) {

            List list = SentHavalehDAO.list();

			httpServletRequest.getSession().setAttribute("SentHavalehList", list);

            return actionMapping.findForward("senthavaleh.update.list");

        }

        return actionMapping.findForward("error");
    }

    protected Object makeEntityFromForm(ActionForm actionForm) {
        SentHavalehForm shf = (SentHavalehForm) actionForm;
        SentHavalehEntity she = new SentHavalehEntity();

        she.setAddress(shf.getAddress());
        she.setTel(shf.getTel());
        Date d = new Date(System.currentTimeMillis());
        she.setDate(d);
        she.setState("ISSUED");

        return she;
    }

    protected ActionForm makeFormFromEntity(Object o) {
        SentHavalehEntity she = (SentHavalehEntity) o;
        SentHavalehForm shf = new SentHavalehForm();

        shf.setAddress(she.getAddress());
        shf.setTel(she.getTel());
        shf.setDate(she.getDate());

        return shf;
    }
}
