package entity;

import java.sql.Date;
import java.util.Set;

/**
 * @hibernate.class
 * table = "jxxsenthavaleh"
 */
public class SentHavalehEntity extends BaseEntity{
    private Long ID;
    private String address;
    private String tel;
    private Date date;
    private String state;

    private Set havalehListGoodSet;
    private Set productionOrderSet;
    private Set transportationDocumentSet;
//    private ProductionOrderEntity productionOrderEntity;
//    private TransportationDocumentEntity transportationDocumentEntity;

    public SentHavalehEntity() {
    }

    /**
     * @hibernate.id
     * generator-class="increment"
     */
    public Long getID() {
        return ID;
    }

    public void setID(Long ID) {
        this.ID = ID;
    }

    /**
     * @hibernate.property
     */
    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    /**
     * @hibernate.property
     */
    public String getTel() {
        return tel;
    }

    public void setTel(String tel) {
        this.tel = tel;
    }

    /**
     * @hibernate.property
     */
    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

	/**
	* @hibernate.property
	*/
	public String getState() {
		return state;
	}
		
	public void setState(String state) {
		this.state = state;
	}

    /**
     * @hibernate.set lazy="false"
     *
     * @hibernate.collection-one-to-many class="entity.HavalehListGoodEntity"
     * @hibernate.collection-key column="sentHavalehIDFK"
     */
    public Set getHavalehListGoodSet() {
        return havalehListGoodSet;
    }

    public void setHavalehListGoodSet(Set havalehListGoodSet) {
        this.havalehListGoodSet = havalehListGoodSet;
    }

    /**
     * @hibernate.set lazy="false"
     *
     * @hibernate.collection-one-to-many class="entity.ProductionOrderEntity"
     * @hibernate.collection-key column="sentHavalehIDFK"
     * unique="true"
     */
	public Set getProductionOrderSet() {
		return productionOrderSet;
	}
	
	public void setProductionOrderSet(Set productionOrderSet) {
		this.productionOrderSet = productionOrderSet;
	}

    /**
     * @hibernate.set lazy="false"
     *
     * @hibernate.collection-one-to-many class="entity.TransportationDocumentEntity"
     * @hibernate.collection-key column="sentHavalehIDFK"
     * unique="true"
     */
	public Set getTransportationDocumentSet() {
		return transportationDocumentSet;
	}

	public void setTransportationDocumentSet(Set transportationDocumentSet) {
		this.transportationDocumentSet = transportationDocumentSet;
	}
}
