package taglibs;


import logging.GeneralLog;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;

public class Table extends TagSupport {
    private List list;
    private String align = "center";
    private String header = null;
    private int border = 0;
    private int size;
    private int titleLength;


    public int doStartTag() throws JspException {
        JspWriter out = pageContext.getOut();
        try {
            out.println("\n\t<table align ='" + align + "' border='1' > ");

            if ((header != null) && (!header.equals(""))) {
                out.println("\n\t\t<tr bgcolor = '#0066FF'><td>\n\t\t\t<table align = 'center' border ='" + border + "' >");
                out.println("\n\t\t\t<tr><td>" + header + "</td></tr>" +
                        "\n\t\t</table></td></tr>");
            }


            out.println("\n\t\t<tr><td>\n\t\t\t<table align ='" + align + "' border = '" + border + "'");
            int rowCounter = 0;//the attribute is used for table colourful;
            for (Iterator iterator = list.iterator(); iterator.hasNext();) {

                TableNode tableNode = (TableNode) iterator.next();
                out.println("\t\t<tr " + ((rowCounter % 2 == 1) ? "bgcolor = '#33CCFF'" : "") + ">" +
                        "<td>" + (tableNode.isShow() ? tableNode.getTitle() : "&nbsp;") + "</td>");
                if (tableNode.getType().equalsIgnoreCase("combo")) {
                    out.print("<td>" + makeComboList(tableNode) + "</td>");
                } else {
                    out.print("<td><input type = '" + ((tableNode.isShow() == true) ? tableNode.getType() : "hidden ") + "' name =\"" +
                            tableNode.getName() + "" +
                            "\" size = '" + getSize() + "'" +
                            " class ='textbox'/>");
                }
                out.print("</td></tr>");
                rowCounter++;
            }
            out.println("\n\t\t\t</table>");
            out.println("\n\t</td></tr>\n\t</table>");
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }
        return super.doStartTag();
    }

    private String makeComboList(TableNode tableNode) {
        List comboList = tableNode.getComboList();
        if (comboList == null) {
            GeneralLog.write("The combo list is emty");
        } else {
            String result = "\n<select name = '" + tableNode.getName() + "' >\n";
            for (Iterator iterator = comboList.iterator(); iterator.hasNext();) {
                String item = (String) iterator.next();
                result += "\n<option>" + item + "<option>";

            }
            result += "\n</select>";
            return result;
        }
        String result = "\n<select name = '" + tableNode.getName() + "' >\n";
//        QueryProcess queryProcess = new QueryProcess();
//        ResultSet rs = queryProcess.execQuery(tableNode.getQuery());
//        try {
//            while (rs.next() )
//            {
//                result += "\n<option>"+rs.getString(tableNode.getQueryColumn()) +"<option>";
//            }
//            result+= "\n</select>";
//        } catch (SQLException e) {
//            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
//        }
//
//        return result ;
        return null;
    }

    public List getList() {
        return list;
    }

    public void setList(List list) {
        this.list = list;
    }

    public String getAlign() {
        return align;
    }

    public void setAlign(String align) {
        this.align = align;
    }

    public String getHeader() {
        return header;
    }

    public void setHeader(String header) {
        this.header = header;
    }

    public int getBorder() {
        return border;
    }

    public void setBorder(int border) {
        this.border = border;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }

    public int getTitleLength() {
        return titleLength;
    }

    public void setTitleLength(int titleLength) {
        this.titleLength = titleLength;
    }


}
